/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 *
 * (C) Copyright IBM Corp. 2002, 2006 All Rights Reserved.
 * (C) Copyright Webify Solutions, Inc. 2002, 2006 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.fabric.icp.plm.context.extractor;

import com.ibm.websphere.fabric.da.PendingRequest;
import com.ibm.websphere.fabric.da.context.Context;
import com.ibm.websphere.fabric.da.plugin.ContextExtractor;
import com.ibm.websphere.fabric.da.plugin.UnexpectedContentException;
import com.ibm.websphere.fabric.da.types.TypedValue;
import commonj.sdo.DataObject;
import commonj.sdo.Sequence;

/**
 * 
 * @author ravikumarv@in.ibm.com
 *
 */
public class SubmitterOrgContextExtractorImpl implements ContextExtractor, IFabricConstant {
	
	
	
	/**
	 * Default constructor.
	 */
	public SubmitterOrgContextExtractorImpl() {
		super();
	}

	/* (non-Javadoc)
	 * @see com.ibm.websphere.fabric.da.plugin.ContextExtractor#extractContext(PendingRequest arg0) 
	 */
	public Context extractContext(PendingRequest req)
			throws UnexpectedContentException {
		boolean governanceFabricProject = false;
		Context context = req.getContext();
		
		Sequence sequence = (Sequence) req.getFirstBodyElement().get(0);
		
		DataObject requestDataObject = (DataObject) sequence.getValue(0);
		
		String org = null;
		
		org = (String) requestDataObject.get("container/Organization.0/Name");
		
		if (org != null) {
			TypedValue assertionValue = new TypedValue(org);
			context.setSelectionProperty(ROLE_TYPE_ASSERTION_ELEMENT,
					assertionValue);
		}

		TypedValue governanceFabricProjectValue = new TypedValue(
				FABRIC_GOVERNANCE);

		context.setSelectionProperty(FABRIC_GOVERNANCE_VALUE,
				governanceFabricProjectValue);
		return context;}

}